/*
     RUN_ELF - Load and execute big endian ix86 ELF binaries
     Copyright (C) 2001-2002 Martin Blom <martin@blom.org>
     
     This program is free software; you can redistribute it and/or
     modify it under the terms of the GNU General Public License
     as published by the Free Software Foundation; either version 2
     of the License, or (at your option) any later version.
     
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef elfloader_h
#define elfloader_h

struct ELFDynSymbols
{
    char* name;
    void* addr;
};

void*
ELFLoadObject( const char* objname, BPTR* seg, const struct ELFDynSymbols* syms );

void
ELFUnLoadObject( void* obj );

BOOL
ELFGetSymbol( void* obj,
              const char* name,
              void** ptr );

#endif /* elfloader_h */
