/*
     RUN_ELF - Load and execute big endian ix86 ELF binaries
     Copyright (C) 2001-2002 Martin Blom <martin@blom.org>
     
     This program is free software; you can redistribute it and/or
     modify it under the terms of the GNU General Public License
     as published by the Free Software Foundation; either version 2
     of the License, or (at your option) any later version.
     
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

enum
{
  CPU_M68K,
  CPU_IX86
};

enum
{
  MODE_READ,
  MODE_WRITE
};

struct Hit
{
    unsigned long  addr;
    unsigned long  task;
    unsigned long  pc;
    
    unsigned char  cpu;
    unsigned char  mode;
    unsigned short _pad;
    
    struct {
	char read[ 17 ];
	char push_ret[ 5 ];
	char push_page[ 5 ];
	char jmp[ 5 ];
    } insn;
    
    union
    {
	struct
	{
	    unsigned long eflags;
	    unsigned long eax;
	    unsigned long ebx;
	    unsigned long ecx;
	    unsigned long edx;
	    unsigned long esi;
	    unsigned long edi;
	    unsigned long esp;
	    unsigned long ebp;
	} ix86;
	
	struct
	{
	    unsigned long  dregs[8];
	    unsigned long  aregs[8];
	    unsigned short sr;
	    unsigned short _pad;
	} m68k;
    } c;
	
    unsigned long stack[ 16 ];
    char          disasm[ 844 ]; // Make struct size a power of two (1K)
};

struct GuardContext
{
    unsigned char  read_index;
    unsigned char  write_index;
    unsigned char  installed;
    unsigned char  zero_page;
    struct Hit     hits[ 256 ];
};
